using System;
using TSLab.DataSource;

namespace FinInfoCache.Common
{
    public class FinInfoBlock
    {
        /// <summary>
        ///  ( UTC)  
        /// </summary>
        public DateTime LastUpdate { get; set; }

        /// <summary>
        ///  
        /// </summary>
        public double Ask { get; set; }

        /// <summary>
        ///  
        /// </summary>
        public double Bid { get; set; }

        /// <summary>
        ///  .
        /// </summary>
        public double AskVolume { get; set; }

        /// <summary>
        ///  
        /// </summary>
        public double BidVolume { get; set; }

        /// <summary>
        ///        
        /// </summary>
        public double BuyCount { get; set; }

        /// <summary>
        ///         ,     
        /// </summary>
        public double BuySqty { get; set; }

        /// <summary>
        ///        
        /// </summary>
        public double SellCount { get; set; }

        /// <summary>
        ///         ,     
        /// </summary>
        public double SellSqty { get; set; }

        /// <summary>
        ///  ()  
        /// </summary>
        public double TheoriticPrice { get; set; }

        /// <summary>
        ///   , %
        /// </summary>
        public double Volatility { get; set; }

        /// <summary>
        ///  .
        /// </summary>
        public double OpenInterest { get; set; }


        /// <summary>
        ///     <see cref="FinInfo"/>  LastUpdate c   <see cref="FinInfoBlock"/>
        /// </summary>
        /// <param name="fi"></param>
        /// <returns></returns>
        public bool EqualsExceptLastUpdate(FinInfoBlock fi)
        {
            return Ask == fi.Ask &&
                   Bid == fi.Bid &&
                   AskVolume == fi.AskVolume &&
                   BidVolume == fi.BidVolume &&
                   BuyCount == fi.BuyCount &&
                   BuySqty == fi.BuySqty &&
                   SellCount == fi.SellCount &&
                   SellSqty == fi.SellSqty &&
                   TheoriticPrice == fi.TheoriticPrice &&
                   Volatility == fi.Volatility &&
                   OpenInterest == fi.OpenInterest;
        }

        /// <summary>
        ///           0. LastUpdate  .
        /// </summary>
        /// <returns></returns>
        public bool ContainsData()
        {
            return  Ask != 0 ||
                    Bid != 0 ||
                    AskVolume != 0 ||
                    BidVolume != 0 ||
                    BuyCount != 0 ||
                    BuySqty != 0 ||
                    SellCount != 0 ||
                    SellSqty != 0 ||
                    TheoriticPrice != 0 ||
                    Volatility != 0 ||
                    OpenInterest != 0;
        }
    }
}